package com.sun.jmx.snmp.IPAcl;

import java.util.Stack;

class JJTParserState
{
    private Stack<Node> nodes;
    private Stack<Integer> marks;
    private int sp;
    private int mk;
    private boolean node_created;
    
    JJTParserState() {
        this.nodes = new Stack();
        this.marks = new Stack();
        this.sp = 0;
        this.mk = 0;
    }
    
    boolean nodeCreated() {
        return this.node_created;
    }
    
    void reset() {
        this.nodes.removeAllElements();
        this.marks.removeAllElements();
        this.sp = 0;
        this.mk = 0;
    }
    
    Node rootNode() {
        return (Node)this.nodes.elementAt(0);
    }
    
    void pushNode(Node item) {
        this.nodes.push(item);
        ++this.sp;
    }
    
    Node popNode() {
        int sp = this.sp - 1;
        this.sp = sp;
        if (sp < this.mk) {
            this.mk = (int)this.marks.pop();
        }
        return (Node)this.nodes.pop();
    }
    
    Node peekNode() {
        return (Node)this.nodes.peek();
    }
    
    int nodeArity() {
        return this.sp - this.mk;
    }
    
    void clearNodeScope(Node node) {
        while (this.sp > this.mk) {
            this.popNode();
        }
        this.mk = (int)this.marks.pop();
    }
    
    void openNodeScope(Node node) {
        this.marks.push(new Integer(this.mk));
        this.mk = this.sp;
        node.jjtOpen();
    }
    
    void closeNodeScope(Node node, int n) {
        this.mk = (int)this.marks.pop();
        while (n-- > 0) {
            Node popNode = this.popNode();
            popNode.jjtSetParent(node);
            node.jjtAddChild(popNode, n);
        }
        node.jjtClose();
        this.pushNode(node);
        this.node_created = true;
    }
    
    void closeNodeScope(Node node, boolean b) {
        if (b) {
            int nodeArity = this.nodeArity();
            this.mk = (int)this.marks.pop();
            while (nodeArity-- > 0) {
                Node popNode = this.popNode();
                popNode.jjtSetParent(node);
                node.jjtAddChild(popNode, nodeArity);
            }
            node.jjtClose();
            this.pushNode(node);
            this.node_created = true;
        }
        else {
            this.mk = (int)this.marks.pop();
            this.node_created = false;
        }
    }
}
